function [outData,pathname,flag] = sosus
%
%   SOSUS

    flag = 1;
    [filename,pathname] = uigetfile({'*.*'},' Open earthquake file');
    if isequal(filename,0)
%        disp('  User selected Cancel');
        return
    else
        disp('  ----- earthquake data -----');
        disp(['  User selected', fullfile(pathname, filename)]);
    end
	myData = textread(fullfile(pathname, filename), '%s', 'delimiter', '\n', 'whitespace', '','bufsize',500000);
	outData = zeros(length(myData), 15);
nerror = 0;
for i = 1:length(myData)

    try 
            outData(i,1) = str2double(myData{i}(42:50)) ;       % longitude (Western, negative)
            outData(i,2) = str2double(myData{i}(34:41)) ;       % latitude
            outData(i,3) = str2double(myData{i}(1:4));          % Year
            outData(i,10) = str2double(myData{i}(5:7));
            [mo(i) dy(i)] = jday2mody(outData(i,3),outData(i,10));
            outData(i,4) = mo(i); % Month
            outData(i,5) = dy(i); % Day
            outData(i,6) = 0.093.* str2double(myData{i}(72:79)) - 16.47;      % Magnitude  
            outData(i,7) = 0.0;	    % Depth             
            outData(i,8) = str2double(myData{i}(8:9)) ;        % Hour
            outData(i,9) = str2double(myData{i}(10:11)) ;       % Minute
            outData(i,10) = 0.0;                                % Nodal 1: strike
            outData(i,11) = 0.0;                                % Nodal 1: dip
            outData(i,12) = 0.0;                                % Nodal 1: rake
            outData(i,13) = 0.0;                                % Nodal 2: strike
            outData(i,14) = 0.0;                                % Nodal 2: dip
            outData(i,15) = 0.0;                                % Nodal 2: rake
            if isnan(outData(i,1)) || isnan(outData(i,6))
                nerror = nerror + 1;
            end
    catch
      disp(['Import: Problem in line ' num2str(i) ' of ' filename '. Line ignored.']);
      nerror = nerror + 1;
    end
      if nerror > 9
         disp('!! Warning !! This may not be properly formatted ncsc hypoinverse catalog.');
         flag = 0;
         return;
      end

%       b = datestr(outData(:,4),7)
%      outData(:,5)=b 
end

end

% fclose(fid);

% z map format
%
% 1)lon, 2)lat, 3)year, 4)month, 5)day, 6)M, 7)depth, 8)hr, 9)min, 10)strike1, 11)dip1, 12)rake1,
% 13)strike2, 14)dip2, 15)rake2
%